NB. Regular expressions extended for Perl-like substitution
NB. Version 2. To use with the new rplc by Chris Burke as of Oct-99
NB. to do: \xHH

require'strings regex user/rplc'

NB. =========================================================
NB.*rxmain v return ()-less mat from ()-ful pattern
rxmain=: ,:"1@:({."2)

NB. =========================================================
NB.*rxs v make Perl-like s/PAT/REPL/OPT substitution
NB. use:
NB.   '/PAT/REPL/OPT' rsx str
NB. PAT - the usual POSIX pattern used in J regex
NB. REPL - the POSIX sed-like replacement string
NB.   \1-\9   corresponding parens content
NB.   \0 or & whole match
NB.   \_      whole match in string representation (for 'e')
NB.   \t      TAB
NB.   \n      LF
NB.   \r      CR
NB.   \f      FF
NB.   \other  other
NB. OPT - any of 'ige' for ignore case, global, execute
NB. see: examples

RBEGE=: <;._1' \n LF \r CR \t TAB \f FF'
RBEGX=: '\n';LF;'\r';CR;'\t';TAB;'\f';FF

rxs=: 4 : 0
esc=. {.x.
'pat rpl opt'=. 3{. <;._1 x.
str=. tolower^:('i'e. opt) y.
pat=. tolower^:('i'e. opt) pat
mat=. pat rxmatch`rxmatches@.('g'e. opt) str
if. (0=#mat) +. _1=1{.,mat do. y. return. end.
subs=. ,:^:(2: > #@$) mat rxfrom y.
mat=. rxmain mat
newr=. ''
  if. 'e' e. opt do.
   r=. rpl rplc '\\';esc;RBEGE
   for_i. i.#mat do.
	pairs=. '&';5!:5<'t' [ t=. >(<i,0){subs
	pairs=. pairs,'\_';'('&,@(,&')')@(5!:5) <'t' [ t=. i{subs
	for_j. i.{:$subs do.
		pairs=. pairs, ('\',":j);5!:5<'t' [ t=. >(<i,j){subs
	end.
	pairs=. pairs,'\';'';esc;'\'
	re=. r rplc pairs
	for_j. i.+/'e'E.opt do.
		re=. (,@":@:".) :: ('__'"_) re
	end.
	newr=. newr,<re
   end.
  else.
   r=. rpl rplc '\\';esc;RBEGX
   for_i. i.#mat do.
	pairs=. '&';>(<i,0){subs
	for_j. i.{:$subs do.
		pairs=. pairs, ('\',":j);>(<i,j){subs
	end.
	pairs=. pairs,'\';'';esc;'\'
	newr=. newr,<r rplc pairs
   end.
  end.
newr mat rxmerge y.
)

0 : 0 NB. ================================================== examples
   str=. 'hello Mr John Dow hi miz Sarah Bernard hi mr none'
   '/(mr|miz) ([a-z]+) ([a-z]+) */\3, \2 (\1) -- was: \0\n' rxs str
hello Mr John Dow hi miz Sarah Bernard hi mr none
   '/(mr|miz) ([a-z]+) ([a-z]+) */\3, \2 (\1) -- was: \0\n/i' rxs str
hello Dow, John (Mr) -- was: Mr John Dow 
hi miz Sarah Bernard hi mr none
   '/(mr|miz) ([a-z]+) ([a-z]+) */\3, \2 (\1) -- was: \0\n/ig' rxs str
hello Dow, John (Mr) -- was: Mr John Dow 
hi Bernard, Sarah (miz) -- was: miz Sarah Bernard 
hi mr none

   p1=. '!(mr|miz) (([a-z]+) )?([a-z]+) *'
   r1=. '!\4,s,(":#\4),s, \3, s,\1,s,'' used: '',(":+/a:~:\_),\n [ s=.''/'''
   o1=. '!gie'
   (p1,r1,o1) rxs str
hello Dow/3/John/Mr/ used: 5
hi Bernard/7/Sarah/miz/ used: 5
hi none/4//mr/ used: 3
)

0 : 0 NB. ================================================== the idea
   'a(.)b|b(.)c' rxmatches 'azb bwc'
 0 3
 1 1
_1 0

 4 3
_1 0
 5 1
   'a(.)b|b(.)c' (rxmatches rxfrom ]) 'azb bwc'
Ŀ
azbz 
Ĵ
bwc w

   'a(.)b|b(.)c' rxmain@rxmatches 'azb bwc'
0 3

4 3
   'a(.)b|b(.)c' (rxmain@rxmatches rxfrom ]) 'azb bwc'
Ŀ
azb
Ĵ
bwc

   'a(.)b|b(.)c' rxmain@rxmatch 'azb bwc'
0 3
   'a(.)b|b(.)c' (rxmain@rxmatch rxfrom ]) 'azb bwc'
Ŀ
azb

)
